Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.pattern
Class VennPattern

    java.lang.Object
      net.sf.saxon.pattern.Pattern
          net.sf.saxon.pattern.VennPattern

All Implemented Interfaces:
  Serializable, SourceLocator, Container, PatternFinder

Direct Known Subclasses:
  ExceptPattern, IntersectPattern, UnionPattern

    public abstract class VennPattern

extends Pattern

A pattern formed as the union, intersection, or difference of two other patterns

See Also:
  Serialized Form

Field Summary
`protected Pattern` | `p1`
`protected Pattern` | `p2`

Constructor Summary
`VennPattern(Pattern p1, Pattern p2)` Constructor

Method Summary
`int` | `allocateSlots(StaticContext env, SlotManager slotManager, int nextFree)` Allocate slots to any variables used within the pattern
`Pattern` | `analyze(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Type-check the pattern.
`boolean` | `equals(Object other)` Determine whether this pattern is the same as another pattern
`void` | `gatherComponentPatterns(Set set)` Gather the component (non-Venn) patterns of this Venn pattern
`int` | `getDependencies()` Get the dependencies of the pattern.
`ItemType` | `getItemType()` Get an ItemType that all the items matching this pattern must satisfy
`Pattern` | `getLHS()` Get the LHS of the union
`int` | `getNodeKind()` Determine the types of nodes to which this pattern applies.
`Pattern` | `getRHS()` Get the RHS of the union
`int` | `hashCode()` Hashcode supporting equals()
`Iterator` | `iterateSubExpressions()` Iterate over the subexpressions within this pattern
`void` | `promote(PromotionOffer offer, Expression parent)` Offer promotion for subexpressions within this pattern.
`boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace a subexpression by a replacement subexpression
`void` | `resolveCurrent(LetExpression let, PromotionOffer offer, boolean topLevel)` If the pattern contains any calls on current(), this method is called to modify such calls to become variable references to a variable declared in a specially-allocated local variable
`void` | `setExecutable(Executable executable)` Set the executable containing this pattern
`void` | `setLineNumber(int lineNumber)` Override method to set the system ID, so it's set on both halves
`void` | `setOriginalText(String pattern)` Set the original text
`void` | `setSystemId(String systemId)` Override method to set the system ID, so it's set on both halves
`Pattern` | `simplify(ExpressionVisitor visitor)` Simplify the pattern: perform any context-independent optimisations

Methods inherited from class net.sf.saxon.pattern.Pattern
`getColumnNumber, getContainerGranularity, getDefaultPriority, getExecutable, getFingerprint, getHostLanguage, getLineNumber, getLocationProvider, getPublicId, getSystemId, internalMatches, make, matches, matchesBeneathAnchor, selectNodes, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### p1

    protected Pattern p1

### p2

    protected Pattern p2

Constructor Detail

### VennPattern

    public VennPattern(Pattern p1,
                       Pattern p2)

  Constructor

  Parameters:
    `p1` - the left-hand operand
    `p2` - the right-hand operand

Method Detail

### setExecutable

    public void setExecutable(Executable executable)

  Set the executable containing this pattern

  Overrides:
    `setExecutable` in class `Pattern`
  Parameters:
    `executable` - the executable

### simplify

    public Pattern simplify(ExpressionVisitor visitor)
                     throws XPathException

  Simplify the pattern: perform any context-independent optimisations

  Overrides:
    `simplify` in class `Pattern`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the optimised Pattern
  Throws:
    `XPathException`

### analyze

    public Pattern analyze(ExpressionVisitor visitor,
                           ExpressionVisitor.ContextItemType contextItemType)
                    throws XPathException

  Type-check the pattern. This is only needed for patterns that contain variable references or function calls.

  Overrides:
    `analyze` in class `Pattern`
  Parameters:
    `visitor` - the expression visitor
    `contextItemType` - the type of the context item at the point where the pattern is defined. Set to null if it is known that the context item is undefined.
  Returns:
    the optimised Pattern
  Throws:
    `XPathException`

### resolveCurrent

    public void resolveCurrent(LetExpression let,
                               PromotionOffer offer,
                               boolean topLevel)
                        throws XPathException

  If the pattern contains any calls on current(), this method is called to modify such calls to become variable references to a variable declared in a specially-allocated local variable

  Overrides:
    `resolveCurrent` in class `Pattern`
  Parameters:
    `let` - the expression that assigns the local variable. This returns a dummy result, and is executed just before evaluating the pattern, to get the value of the context item into the variable.
    `offer` - A PromotionOffer used to process the expressions and change the call on current() into a variable reference
    `topLevel` -
  Throws:
    `XPathException`

### promote

    public void promote(PromotionOffer offer,
                        Expression parent)
                 throws XPathException

  Offer promotion for subexpressions within this pattern. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Unlike the corresponding method on `Expression`, this method does not return anything: it can make internal changes to the pattern, but cannot return a different pattern. Only certain kinds of promotion are applicable within a pattern: specifically, promotions affecting local variable references within the pattern.

  Overrides:
    `promote` in class `Pattern`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
    `parent` -
  Throws:
    `XPathException` - if any error is detected

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace a subexpression by a replacement subexpression

  Overrides:
    `replaceSubExpression` in class `Pattern`
  Parameters:
    `original` - the expression to be replaced
    `replacement` - the new expression to be inserted in its place
  Returns:
    true if the replacement was carried out

### setOriginalText

    public void setOriginalText(String pattern)

  Set the original text

  Overrides:
    `setOriginalText` in class `Pattern`
  Parameters:
    `pattern` - the original text of the pattern

### allocateSlots

    public int allocateSlots(StaticContext env,
                             SlotManager slotManager,
                             int nextFree)

  Allocate slots to any variables used within the pattern

  Overrides:
    `allocateSlots` in class `Pattern`
  Parameters:
    `env` - the static context in the XSLT stylesheet
    `slotManager` -
    `nextFree` - the next slot that is free to be allocated @return the next slot that is free to be allocated
  Returns:
    the next slot that is free to be allocated

### gatherComponentPatterns

    public void gatherComponentPatterns(Set set)

  Gather the component (non-Venn) patterns of this Venn pattern

  Parameters:
    `set` - the set into which the components will be added

### getNodeKind

    public int getNodeKind()

  Determine the types of nodes to which this pattern applies. Used for optimisation. For patterns that match nodes of several types, return Node.NODE

  Overrides:
    `getNodeKind` in class `Pattern`
  Returns:
    the type of node matched by this pattern. e.g. Node.ELEMENT or Node.TEXT

### getItemType

    public ItemType getItemType()

  Get an ItemType that all the items matching this pattern must satisfy

  Specified by:
    `getItemType` in class `Pattern`
  Returns:
    an ItemType, as specific as possible, which all the matching items satisfy

### getDependencies

    public int getDependencies()

  Get the dependencies of the pattern. The only possible dependency for a pattern is on local variables. This is analyzed in those patterns where local variables may appear.

  Overrides:
    `getDependencies` in class `Pattern`
  Returns:
    the dependencies, as a bit-significant mask

### iterateSubExpressions

    public Iterator iterateSubExpressions()

  Iterate over the subexpressions within this pattern

  Overrides:
    `iterateSubExpressions` in class `Pattern`
  Returns:
    an iterator over the subexpressions.

### getLHS

    public Pattern getLHS()

  Get the LHS of the union

  Returns:
    the first operand of the union

### getRHS

    public Pattern getRHS()

  Get the RHS of the union

  Returns:
    the second operand of the union

### setSystemId

    public void setSystemId(String systemId)

  Override method to set the system ID, so it's set on both halves

  Overrides:
    `setSystemId` in class `Pattern`
  Parameters:
    `systemId` - the URI of the module containing the pattern

### setLineNumber

    public void setLineNumber(int lineNumber)

  Override method to set the system ID, so it's set on both halves

  Overrides:
    `setLineNumber` in class `Pattern`
  Parameters:
    `lineNumber` - the line number of the pattern in the source module

### equals

    public boolean equals(Object other)

  Determine whether this pattern is the same as another pattern

  Overrides:
    `equals` in class `Object`
  Parameters:
    `other` - the other object

### hashCode

    public int hashCode()

  Hashcode supporting equals()

  Overrides:
    `hashCode` in class `Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.